GNU Radio C++ API Reference: gr::channels::dynamic_channel_model Class Reference

| GNU Radio C++ API Reference 3.10.12.0 The Free & Open Software Radio Ecosystem |

Loading...
Searching...
No Matches
gr::channels::dynamic_channel_model Class Referenceabstract

dynamic channel simulator More...

`#include <gnuradio/channels/dynamic_channel_model.h>`

## Public Types
typedef std::shared_ptr< dynamic_channel_model > | sptr
Public Types inherited from gr::hier_block2
typedef basic_block_sptr | opaque_self
| typedef for object returned from self().

## Public Member Functions
virtual double | samp_rate () const =0
virtual double | sro_dev_std () const =0
virtual double | sro_dev_max () const =0
virtual double | cfo_dev_std () const =0
virtual double | cfo_dev_max () const =0
virtual double | noise_amp () const =0
virtual double | doppler_freq () const =0
virtual double | K () const =0
virtual void | set_samp_rate (double)=0
virtual void | set_sro_dev_std (double)=0
virtual void | set_sro_dev_max (double)=0
virtual void | set_cfo_dev_std (double)=0
virtual void | set_cfo_dev_max (double)=0
virtual void | set_noise_amp (double)=0
virtual void | set_doppler_freq (double)=0
virtual void | set_K (double)=0
Public Member Functions inherited from gr::hier_block2
| ~hier_block2 () override
opaque_self | self ()
| Return an object, representing the current block, which can be passed to connect.
void | connect (basic_block_sptr block)
| Add a stand-alone (possibly hierarchical) block to internal graph.
void | connect (basic_block_sptr src, int src_port, basic_block_sptr dst, int dst_port)
| Add gr-blocks or hierarchical blocks to internal graph and wire together.
void | msg_connect (basic_block_sptr src, pmt::pmt_t srcport, basic_block_sptr dst, pmt::pmt_t dstport)
| Add gr-blocks or hierarchical blocks to internal graph and wire together.
void | msg_connect (basic_block_sptr src, std::string srcport, basic_block_sptr dst, std::string dstport)
void | msg_disconnect (basic_block_sptr src, pmt::pmt_t srcport, basic_block_sptr dst, pmt::pmt_t dstport)
void | msg_disconnect (basic_block_sptr src, std::string srcport, basic_block_sptr dst, std::string dstport)
void | disconnect (basic_block_sptr block)
| Remove a gr-block or hierarchical block from the internal flowgraph.
void | disconnect (basic_block_sptr src, int src_port, basic_block_sptr dst, int dst_port)
| Disconnect a pair of gr-blocks or hierarchical blocks in internal flowgraph.
void | disconnect_all ()
| Disconnect all connections in the internal flowgraph.
virtual void | lock ()
virtual void | unlock ()
int | max_output_buffer (size_t port=0)
| Returns max buffer size (itemcount) on output port `i`.
void | set_max_output_buffer (int max_output_buffer)
| Sets max buffer size (itemcount) on all output ports.
void | set_max_output_buffer (size_t port, int max_output_buffer)
| Sets max buffer size (itemcount) on output port `port`.
int | min_output_buffer (size_t port=0)
| Returns min buffer size (itemcount) on output port `i`.
void | set_min_output_buffer (int min_output_buffer)
| Sets min buffer size (itemcount) on all output ports.
void | set_min_output_buffer (size_t port, int min_output_buffer)
| Sets min buffer size (itemcount) on output port `port`.
flat_flowgraph_sptr | flatten () const
hier_block2_sptr | to_hier_block2 ()
bool | has_msg_port (pmt::pmt_t which_port) override
bool | message_port_is_hier (pmt::pmt_t port_id) override
bool | message_port_is_hier_in (pmt::pmt_t port_id) override
bool | message_port_is_hier_out (pmt::pmt_t port_id) override
void | message_port_register_hier_in (pmt::pmt_t port_id)
void | message_port_register_hier_out (pmt::pmt_t port_id)
void | set_processor_affinity (const std::vector< int > &mask) override
| Set the affinity of all blocks in hier_block2 to processor core `n`.
void | unset_processor_affinity () override
| Remove processor affinity for all blocks in hier_block2.
std::vector< int > | processor_affinity () override
| Get the current processor affinity.
void | set_log_level (const std::string &level) override
| Set the logger's output level.
std::string | log_level () override
| Get the logger's output level.
bool | all_min_output_buffer_p (void)
| Get if all block min buffers should be set.
bool | all_max_output_buffer_p (void)
| Get if all block max buffers should be set.
Public Member Functions inherited from gr::basic_block
pmt::pmt_t | message_subscribers (pmt::pmt_t port)
| ~basic_block () override
long | unique_id () const
long | symbolic_id () const
std::string | name () const
std::string | symbol_name () const
std::string | identifier () const
gr::io_signature::sptr | input_signature () const
gr::io_signature::sptr | output_signature () const
basic_block_sptr | to_basic_block ()
bool | alias_set () const
std::string | alias () const
pmt::pmt_t | alias_pmt () const
void | set_block_alias (std::string name)
void | message_port_register_in (pmt::pmt_t port_id)
void | message_port_register_out (pmt::pmt_t port_id)
void | message_port_pub (pmt::pmt_t port_id, pmt::pmt_t msg)
void | message_port_sub (pmt::pmt_t port_id, pmt::pmt_t target)
void | message_port_unsub (pmt::pmt_t port_id, pmt::pmt_t target)
pmt::pmt_t | message_ports_in ()
| Get input message port names.
pmt::pmt_t | message_ports_out ()
| Get output message port names.
void | _post (pmt::pmt_t which_port, pmt::pmt_t msg)
bool | empty_p (pmt::pmt_t which_port)
| is the queue empty?
bool | empty_p ()
bool | empty_handled_p (pmt::pmt_t which_port)
| are all msg ports with handlers empty?
bool | empty_handled_p ()
size_t | nmsgs (pmt::pmt_t which_port)
| How many messages in the queue?
void | insert_tail (pmt::pmt_t which_port, pmt::pmt_t msg)
pmt::pmt_t | delete_head_nowait (pmt::pmt_t which_port)
msg_queue_t::iterator | get_iterator (pmt::pmt_t which_port)
void | erase_msg (pmt::pmt_t which_port, msg_queue_t::iterator it)
const msg_queue_map_t & | get_msg_map (void) const
void | add_rpc_variable (rpcbasic_sptr s)
| Add an RPC variable (get or set).
virtual void | setup_rpc ()
| Set up the RPC registered variables.
bool | is_rpc_set ()
| Ask if this block has been registered to the RPC.
void | rpc_set ()
| When the block is registered with the RPC, set this.
virtual bool | check_topology (int ninputs, int noutputs)
| Confirm that ninputs and noutputs is an acceptable combination.
template<typename T>
void | set_msg_handler (pmt::pmt_t which_port, T msg_handler)
| Set the callback that is fired when messages are available.
Public Member Functions inherited from gr::msg_accepter
| msg_accepter ()
| ~msg_accepter () override
void | post (pmt::pmt_t which_port, pmt::pmt_t msg) override
| send `msg` to `msg_accepter` on port `which_port`
Public Member Functions inherited from gr::messages::msg_accepter
| msg_accepter ()

## Static Public Member Functions
static sptr | make (double samp_rate, double sro_std_dev, double sro_max_dev, double cfo_std_dev, double cfo_max_dev, unsigned int N, double doppler_freq, bool LOS_model, float K, std::vector< float > delays, std::vector< float > mags, int ntaps_mpath, double noise_amp, double noise_seed)
| Build the dynamic channel simulator.

## Additional Inherited Members
Public Attributes inherited from gr::hier_block2
pmt::pmt_t | hier_message_ports_in
pmt::pmt_t | hier_message_ports_out
Protected Types inherited from gr::basic_block
enum | vcolor { WHITE , GREY , BLACK }
Protected Member Functions inherited from gr::hier_block2
| hier_block2 ()
| hier_block2 (const std::string &name, gr::io_signature::sptr input_signature, gr::io_signature::sptr output_signature)
Protected Member Functions inherited from gr::basic_block
| basic_block (void)
| basic_block (const std::string &name, gr::io_signature::sptr input_signature, gr::io_signature::sptr output_signature)
| Protected constructor prevents instantiation by non-derived classes.
void | set_input_signature (gr::io_signature::sptr iosig)
| may only be called during constructor
void | set_output_signature (gr::io_signature::sptr iosig)
| may only be called during constructor
void | set_color (vcolor color)
| Allow the flowgraph to set for sorting and partitioning.
vcolor | color () const
virtual bool | has_msg_handler (pmt::pmt_t which_port)
| Tests if there is a handler attached to port `which_port`.
virtual void | dispatch_msg (pmt::pmt_t which_port, pmt::pmt_t msg)
template<typename Derived>
std::shared_ptr< Derived > | shared_from_base ()
| This is meant to be called by derived classes (e.g. block) to get a shared pointer internally. This is needed because std::enable_shared_from_this doesn't seem to work with derived classes in an inheritance hierarchy.
Protected Attributes inherited from gr::basic_block
std::string | d_name
gr::io_signature::sptr | d_input_signature
gr::io_signature::sptr | d_output_signature
long | d_unique_id
long | d_symbolic_id
std::string | d_symbol_name
std::string | d_symbol_alias
vcolor | d_color
bool | d_rpc_set
gr::logger_ptr | d_logger
gr::logger_ptr | d_debug_logger
| Default logger.
msg_queue_map_t | msg_queue
| Verbose logger.
std::vector< rpcbasic_sptr > | d_rpc_vars
pmt::pmt_t | d_message_subscribers

## Detailed Description

dynamic channel simulator

This block implements a dynamic channel model simulator that can be used to help evaluate, design, and test various signals, waveforms, and algorithms.

This model allows the user to set up an AWGN noise source, a random walk process to simulate carrier frequency drift, a random walk process to simulate sample rate offset drive, and a frequency selective fading channel response that is either Rayleigh or Ricean for a user specified power delay profile.

## Member Typedef Documentation

## ◆ sptr

typedef std::shared_ptr<dynamic_channel_model> gr::channels::dynamic_channel_model::sptr

## Member Function Documentation

## ◆ cfo_dev_max()

virtual double gr::channels::dynamic_channel_model::cfo_dev_max | ( |  | ) | const
| pure virtual

## ◆ cfo_dev_std()

virtual double gr::channels::dynamic_channel_model::cfo_dev_std | ( |  | ) | const
| pure virtual

## ◆ doppler_freq()

virtual double gr::channels::dynamic_channel_model::doppler_freq | ( |  | ) | const
| pure virtual

Referenced by make().

## ◆ K()

virtual double gr::channels::dynamic_channel_model::K | ( |  | ) | const
| pure virtual

Referenced by make().

## ◆ make()

sptr gr::channels::dynamic_channel_model::make | ( | double | samp_rate,
|  | double | sro_std_dev,
|  | double | sro_max_dev,
|  | double | cfo_std_dev,
|  | double | cfo_max_dev,
|  | unsigned int | N,
|  | double | doppler_freq,
|  | bool | LOS_model,
|  | float | K,
|  | std::vector< float > | delays,
|  | std::vector< float > | mags,
|  | int | ntaps_mpath,
|  | double | noise_amp,
|  | double | noise_seed )
| static

Build the dynamic channel simulator.

Parameters

  samp_rate | Input sample rate in Hz
  sro_std_dev | sample rate drift process standard deviation per sample in Hz
  sro_max_dev | maximum sample rate offset in Hz
  cfo_std_dev | carrier frequnecy drift process standard deviation per sample in Hz
  cfo_max_dev | maximum carrier frequency offset in Hz
  N | number of sinusoids used in frequency selective fading simulation
  doppler_freq | maximum doppler frequency used in fading simulation in Hz
  LOS_model | defines whether the fading model should include a line of site component. LOS->Rician, NLOS->Rayleigh
  K | Rician K-factor, the ratio of specular to diffuse power in the model
  delays | A list of fractional sample delays making up the power delay profile
  mags | A list of magnitudes corresponding to each delay time in the power delay profile
  ntaps_mpath | The length of the filter to interpolate the power delay profile over. Delays in the PDP must lie between 0 and ntaps_mpath, fractional delays will be sinc-interpolated only to the width of this filter.
  noise_amp | Specifies the standard deviation of the AWGN process
  noise_seed | A random number generator seed for the noise source.

References doppler_freq(), K(), noise_amp(), and samp_rate().

## ◆ noise_amp()

virtual double gr::channels::dynamic_channel_model::noise_amp | ( |  | ) | const
| pure virtual

Referenced by make().

## ◆ samp_rate()

virtual double gr::channels::dynamic_channel_model::samp_rate | ( |  | ) | const
| pure virtual

Referenced by make().

## ◆ set_cfo_dev_max()

virtual void gr::channels::dynamic_channel_model::set_cfo_dev_max | ( | double |  | ) |
| pure virtual

## ◆ set_cfo_dev_std()

virtual void gr::channels::dynamic_channel_model::set_cfo_dev_std | ( | double |  | ) |
| pure virtual

## ◆ set_doppler_freq()

virtual void gr::channels::dynamic_channel_model::set_doppler_freq | ( | double |  | ) |
| pure virtual

## ◆ set_K()

virtual void gr::channels::dynamic_channel_model::set_K | ( | double |  | ) |
| pure virtual

## ◆ set_noise_amp()

virtual void gr::channels::dynamic_channel_model::set_noise_amp | ( | double |  | ) |
| pure virtual

## ◆ set_samp_rate()

virtual void gr::channels::dynamic_channel_model::set_samp_rate | ( | double |  | ) |
| pure virtual

## ◆ set_sro_dev_max()

virtual void gr::channels::dynamic_channel_model::set_sro_dev_max | ( | double |  | ) |
| pure virtual

## ◆ set_sro_dev_std()

virtual void gr::channels::dynamic_channel_model::set_sro_dev_std | ( | double |  | ) |
| pure virtual

## ◆ sro_dev_max()

virtual double gr::channels::dynamic_channel_model::sro_dev_max | ( |  | ) | const
| pure virtual

## ◆ sro_dev_std()

virtual double gr::channels::dynamic_channel_model::sro_dev_std | ( |  | ) | const
| pure virtual

The documentation for this class was generated from the following file:

- dynamic_channel_model.h